<template>
  <div class="flex flex-col rounded-lg bg-background5 m-profile-lang-seletion">
    <el-collapse v-model="activeCollapse">
      <el-collapse-item name="language">
        <template #title>
          <div class="flex items-center justify-between w-full pl-3 pr-4 py-1">
            <div class="flex items-center fc-text">
              <div
                class="w-10 h-10 flex items-center justify-center flex-shrink-0"
              >
                <div class="flag-wrapper">
                  <img
                    :src="
                      getAssetImage(
                        `assets/materials/languageIcon/${defaultLanguage}.svg`
                      )
                    "
                    alt="Current Language"
                  />
                </div>
              </div>
              <span class="lang-menu-title">{{
                defaultLanguageForDisplay
              }}</span>
            </div>
            <div class="flex items-center m-angle-right-container">
              <font-awesome-icon
                icon="angle-down"
                class="m-language-collapse"
              />
            </div>
          </div>
        </template>
        <a
          v-for="(lang, index) in languageSetting"
          :id="`lang-${lang.ISO}`"
          :key="index"
          class="flex items-center py-1 fc-text pl-[52px] pr-4 profile-lang-item"
          :class="{ activeLang: defaultLanguage === lang.ISO }"
          @click.prevent="switchLanguage(lang.ISO)"
        >
          <div class="w-10 h-10 flex items-center justify-center flex-shrink-0">
            <div class="flag-wrapper">
              <img
                :src="
                  getAssetImage(`assets/materials/languageIcon/${lang.ISO}.svg`)
                "
                alt="Current Language"
              />
            </div>
          </div>
          <div class="lang-menu-title w-full mr-1">
            {{ lang.LanguageLocalName }}
          </div>
          <IconTick class="w-5 h-5 flex-shrink-0 tc-primary tick-icon" />
        </a>
      </el-collapse-item>
    </el-collapse>
  </div>
</template>

<script setup lang="ts">
import IconTick from "~/assets/icons/tick.svg?component";

const emit = defineEmits<{
  (e: "expanded", lastEl: HTMLElement): void;
}>();

const activeCollapse = ref<string[]>([]);
const { getAssetImage } = commonHelper;

const {
  languageSetting,
  defaultLanguage,
  switchLanguage,
  defaultLanguageForDisplay,
} = useLanguageComponent();

watch(activeCollapse, (collapseItem) => {
  if (collapseItem.length) {
    const lastLang = languageSetting.value[languageSetting.value.length - 1];
    const el = document.getElementById(`lang-${lastLang?.ISO}`);
    if (!el) return;
    setTimeout(() => {
      emit("expanded", el);
    }, 17.25 * languageSetting.value.length);
  }
});
</script>

<style lang="scss">
.m-profile-lang-seletion {
  .el-collapse {
    --el-collapse-header-bg-color: transparent;
    --el-collapse-content-bg-color: transparent;
    border-top: 0;
    border-bottom: 0;
  }

  .lang-menu-title {
    font-family: Roboto;
    font-size: 14px;
    font-weight: 400;
    line-height: 16.41px;
    text-align: left;
    color: var(--text5);
  }

  .el-collapse-item__header {
    &.is-active {
      position: relative;

      &:after {
        content: "";
        position: absolute;
        left: 0;
        bottom: 0;
        width: 100%;
        height: 1px;
        background: var(--borderD500);
      }
    }
  }

  .flag-wrapper {
    width: 22px;
    height: 16px;
    border-radius: 2px;
    border: 1px solid var(--border);
    overflow: hidden;

    & > img {
      transform: scale(1.2);
    }
  }

  .profile-lang-item {
    .tick-icon {
      display: none;
    }

    &.activeLang {
      .tick-icon {
        display: block;
      }

      .lang-menu-title {
        font-weight: 500;
        color: var(--primary);
      }
    }
  }
}
</style>
